.area text
TCNT2 = $B2
TCCR2B = $B1
UCSR0B = $C1
TIMSK2 = $70

;----------------------------------------------------------------------
;void EC0608INIT(void)
;EPCʼ
_EC0608INIT::
	LDI		R24, $C0
	OUT		$05, R24	;Y2-Y7λ(PORTB)
	LDI		R24, $3C
	OUT		$0B, R24	;X0-X3(ROPTD)
	LDI		R24, $03
	OUT		$08, R24	;X4-X6, Y0-Y1λ(PORTC)
	LDI		R24, $3F
	OUT		$04, R24	;DDRB  
	LDI		R24, $C0
	OUT		$0A, R24	;DDRD
	LDI		R24, $30
	OUT		$07, R24	;RUNָʾRS485˿Ϊ(DDRC)
	
_clr_memory:
	LDI		R30, <_MB
	LDI		R31, >_MB
	CLR		R24
	LDI		R25, 0xE0
loop_clr_mem:
	ST		Z+, R24
	DEC		R25
	TST		R25
	BRNE	loop_clr_mem
	LDI		R24, 0xAA
	ST		Z, R24
	
;UBRR0 = 0x3B 9.216MHz9600Kbps
	LDI		R24, $3B
	LDI		R25, $0
	STS		$00C5, R25
	STS		$00C4, R24
	
	CBI		$08, 5  ;485Ϊģʽ(PORTC,5)
	STS		_buf_RX+17, R25	;buf_RX[17] = 0
	LDI		R24, $01
	STS		_buf_TX, R24	;buf_TX[0] = 1
	STS		TIMSK2, R24		;T2ж
	LDI		R24, $90
	STS		UCSR0B, R24		;USARTжϺRXD
	LDI		R24, $02
	STS		_tmr_UCS, R24	;ͨųʱʱֵ20mS
	LDI		R24, $A6
	STS		TCNT2, R24		;T0ֵ, Լ10mSжһ
	LDI		R24, $07
	STS		TCCR2B, R24		;T2ʹ1024Ƶ
	SEI
	LDS		R24,_relay_MD+7
	ORI		R24, $80	;M63λ
	STS		_relay_MD+7, R24 
	RCALL	_scan_xn
	RCALL	.+2
	POP		R25
	POP		R24
	ADIW	R24, $20
	STS		_mLOOP_L, R24 ;_loop_nextַ
	STS		_mLOOP_H, R25
	POP		R24
	STS		_uLOOP_H, R24 ;ûַ
	POP		R24
	STS		_uLOOP_L, R24
	SBIW	R28, $1
_main_loop:
	LDS	   R24, _relay_MD+7
	SBRS   R24, 6
	RJMP   _main_loop
	LDS	   R24, _mLOOP_L
	PUSH   R24	;ѹѭַλ
	LDS	   R24, _mLOOP_H
	PUSH   R24	;ѹѭַλ
	LDS	   R24, _uLOOP_L
	PUSH   R24	;ѹûַλ
	LDS	   R24, _uLOOP_H
	PUSH   R24	;ѹûַλ
	LD	   R24, Y+
	RET ;RETָʵתûִû
_loop_next:
	ST	   -Y, R24			;R24ֵ
	LDS	   R24, _relay_MD+7	;ȡM57-M63
	ANDI   R24, $3F			;M62 & M63 λ
	STS	   _relay_MD+7, R24	;дM57-M63
	RJMP   _main_loop